{% extends "scandb_base.html" %}

{% load i18n %}
{% load static %}

{% block title %}
{% blocktrans with report_id=report_db.id vendor=report.scanner.vendor model=report.scanner.model %}
Scan report {{ report_id }} - {{ vendor }} {{ model }}
{% endblocktrans %}
{% endblock %}


{% block scandb_body %}

{% if report_db.admin_comment %}
{% blocktrans with admin_comment=report_db.admin_comment %}
<h2>Report status</h2>
<p style="font-weight: bold; color: #FF0000;">Administrator comment:</p>
<p>{{ admin_comment }}</p>
<p>Moderator: <a href="mailto:jflesch@openpaper.work">Jerome Flesch</a></p>
{% endblocktrans %}
{% elif not report_db.moderated %}
<h2>Report status</h2>
<p>Report not moderated yet</p>
<p>Moderator: <a href="mailto:jflesch@openpaper.work">Jerome Flesch</a></p>
{% endif %}

{% if user.is_authenticated %}
<table>
    <tr style="text-align: center;">
        {% if not report_db.moderated %}
        <td>
            <form action="{% url 'scannerdb:validate_report' report_db.id %}" method="post">
                {% csrf_token %}
                <input type="submit" value="Validate" />
            </form>
        </td>
        {% endif %}
        <td>
            <form action="{% url 'scannerdb:delete_report' report_db.id %}" method="post">
                {% csrf_token %}
                <input type="submit" value="Delete" />
            </form>
        </td>
        <td>
            <form action="{% url 'scannerdb:analyze_report' report_db.id %}" method="post">
                {% csrf_token %}
                <input type="submit" value="Analyze" />
            </form>
        </td>
        <td>
            <a href="{% url "admin:backend_scanreport_change" report_db.id %}">[admin]</a>
        </td>
    </tr>
    <tr style="text-align: center;">
        <td colspan="3">
            <form action="{% url 'scannerdb:comment_report' report_db.id %}" method="post">
                {% csrf_token %}
                {% for field in admin_comment_form %}
                {{ field }}
                {% endfor %}
                <input type="submit" value="Comment" />
            </form>
        </td>
    </tr>
</table>
{% endif %}

<h2>{% trans "Scanner" %}</h2>

<button class="scandb_accordion">{% trans "Information" %}</button>
<div class="scandb_panel scandb_active scandb_panel_extended">
    <table>
        <tr>
            <td>
                <ul>
                    {% blocktrans with vendor=report.scanner.vendor model=report.scanner.model nicename=report.scanner.nicename devid=report.scanner.devid type=report.scanner.type.title %}
                    <li>Manufacturer: {{ vendor }}</li>
                    <li>Model: {{ model }}</li>
                    <li>Nice name: {{ nicename }}</li>
                    <li>Device ID: {{ devid }}</li>
                    <li>Type: {{ type }}</li>
                    {% endblocktrans %}
                </ul>
            </td>
            <td>
                <img src="{% static scanner_type_img %}" alt="scanner type" />
            </td>
        </tr>
    </table>
</div>

{% if report.scanner.picture %}
<button class="scandb_accordion">{% trans "Photo" %}</button>
<div class="scandb_panel">
    <img src="{% url 'scannerdb_no_i18n:scanner_photo' report_db.id %}" alt="scanner photo" />
</div>
{% endif %}

<button class="scandb_accordion">{% trans "Available Settings" %}</button>
<div class="scandb_panel">
    <ol>
        {% for option in report.scanner.options.items %}
        <li>
            <div class="scandb_accordion">{{ option.0 }}</div>
            <div class="scandb_panel">
                <ul>
                    {% for opt_element in option.1.items %}
                    <li>{{ opt_element.0 }}: {{ opt_element.1 }}</li>
                    {% endfor %}
                </ul>
            </div>
        </li>
        {% endfor %}
    </ol>
</div>

<h2>{% trans "Test scan" %}</h2>

{% blocktrans with successful=successful os=report_db.os.title %}
<p>OS: {{ os }}</p>
<p>Test successful: {{ successful }}</p>
{% endblocktrans %}

<button class="scandb_accordion">{% trans "Configuration" %}</button>
<div class="scandb_panel">
    <ul>
        {% with config=report.scantest.config %}
        {% blocktrans with source=config.source resolution=config.resolution mode=config.mode %}
        <li>Source: {{ source }}</li>
        <li>Resolution: {{ resolution }} dpi</li>
        <li>Mode: {{ mode }}</li>
        {% endblocktrans %}
        {% endwith %}
    </ul>
</div>

{% if report.user.comment %}
<button class="scandb_accordion">{% trans "User comment" %}</button>
<div class="scandb_panel">
    <pre>{{ report.user.comment }}</pre>
</div>
{% endif %}

<button class="scandb_accordion">{% trans "Traces" %}</button>
<div class="scandb_panel">
    <p>
        {% for attachment in attachments %}
        {% if attachment.mime_type == "text/plain" %}
        {{ attachment.file_name }}:
        <a href="{{ attachment.download_url }}">[raw]</a>
        <a href="{% url 'scannerdb:report_traces_colorized' report_db.id attachment.id %}">[colorized]</a>
        {% endif %}
        {% endfor %}
    </p>
</div>

<button class="scandb_accordion">{% trans "Scan result" %}</button>
<div class="scandb_panel">
    <p>
        {% for attachment in attachments %}
        {% if attachment.is_image %}
        {{ attachment.file_name }}:<br/>
        <img src="{{ attachment.download_url }}" alt="scan result {{ attachment.file_name }}" />
        {% endif %}
        {% endfor %}
    </p>
    <ul>
        {% for attachment in attachments %}
        {% if not attachment.is_image %}
        <li>
            <a href="{{ attachment.download_url }}">{{ attachment.file_name }}</a>
        </li>
        {% endif %}
        {% endfor %}
    </ul>
</div>


<h2>{% trans "Additional information" %}</h2>

<button class="scandb_accordion">{% trans "Software" %}</button>
<div class="scandb_panel">
    <ul>
        <li>OS type: {{ report.system.sys_os_name }}</li>
        <li>Test program: {{ report.system.versions.test_program }}</li>
        <li>Scan library: {{ report.system.versions.scan_library }}</li>
        <li>Pillow: {{ report.system.versions.pillow }}</li>
        <li>Python version: {{ report.system.sys_software_python }}</li>
        <li>Architecture: {{ report.system.sys_platform_architecture }}</li>
        <li>Platform:
            <ul>
                <li>Short: {{ report.system.sys_software_system }}</li>
                <li>Detailed: {{ report.system.sys_platform_distribution }}</li>
                <li>Release: {{ report.system.sys_software_release }}</li>
                <li>System: {{ report.system.sys_software_system }}</li>
            </ul>
        </li>
    </ul>
</div>

<button class="scandb_accordion">{% trans "Hardware" %}</button>
<div class="scandb_panel">
    <ul>
        <li>Architecture: {{ report.system.sys_platform_architecture }}</li>
        <li>CPU frequency: {{ report.system.sys_cpu_freq }}</li>
        <li>Number of CPUs: {{ report.system.sys_cpu_count }}</li>
        <li>Processor: {{ report.system.sys_platform_processor }}</li>
        <li>Machine: {{ report.system.sys_platform_machine }}</li>
        <li>Memory: {{ report.system.sys_platform_mem }}</li>
    </ul>
</div>

{% if report.user.name %}
<button class="scandb_accordion">Reporter</button>
<div class="scandb_panel">
    <p>Reported by:
    {% if user.is_authenticated and report_db.user_email %}
    <a href="mailto:{{ report_db.user_email }}">{{ report.user.name }}</a>
    {% else %}
    [{{ report.user.name }}]
    {% endif %}
    </p>
</div>
{% endif %}

<p>REST API link:
    <a href="{% url 'scanreport-detail' report_db.id %}">
        {% url 'scanreport-detail' report_db.id %}
    </a>
</p>

<script type="text/javascript">
var acc = document.getElementsByClassName("scandb_accordion");
var i;

for (i = 0; i < acc.length; i++) {
    acc[i].addEventListener("click", function() {
        this.classList.toggle("scandb_active");

        var panel = this.nextElementSibling;
        if (panel.style.display === "block") {
            panel.style.display = "none";
            panel.style.overflow = "hidden";
        } else {
            panel.style.display = "block";
            panel.style.overflow = "auto";
        }
    });
}
</script>

{% endblock %}
